%import syslib
%import string
%import graphics
%import floats
%import conv

main {

str wfilenam = "@0:hiscores.dat,s,w"
str rfilenam = "@0:hiscores.dat,s,r"
str[10] names = ["1??","2??","3??","4??","5??","6??","7??","8??","9??","a??"]
str[10] scores = ["10000","20000","30000","40000","50000","60000","70000","80000","90000","11000"]
;str[10] scorted = ["99000","88000","77000","66000","55000","44000","33000","22000","34000","12000"]
;str[10] snames = ["1??","2??","3??","4??","5??","6??","7??","8??","9??","a??"]

str p_str = "???"
str s_str = "??????"
uword top_score
uword scor

sub start() {
	ubyte r

	    void cx16.screen_mode(3, false)     ; low res
    	txt.color2(9,0)                     
    	txt.clear_screen()
    	
    	get_player()
    	
    	repeat {
 		   	read_hiscores()
 		   	print_hiscores()
 		   	getkey()
 		   	
  			get_score()
    		r = check_score(scor)
    	 	
    		print_hiscores()
    	  	
    		getkey()
    		
    		write_hiscores()
    		sys.wait(5)
    	}
    	
}

sub read_hiscores() {
	ubyte row
	ubyte cnt
	ubyte ch
	ubyte lgth
	ubyte[4] hname
	ubyte[7] hscore
	ubyte st

		
	lgth = string.length(rfilenam)
	
	cbm.SETLFS(2, 8, 2)
	
	cbm.SETNAM(lgth, rfilenam)
	
	cbm.OPEN()
	
	st = cbm.READST()
	if st != 0 {
		txt.plot(20,0)
		txt.print("error ")
	    txt.print_ub(st) 
		getkey()
		}
		
		
	cbm.CHKIN(2)
	
	for row in 0 to 9 {	
		cnt = 0
		ch = 0
		while ch != 13 {
		  ch = cbm.CHRIN()
		  hname[cnt] = ch
	          cnt += 1 }
		  hname[3] = 0
		  ;ch = cbm.CHRIN()
		string.copy(&hname,names[row])
		cnt = 0
		ch = 0
		while ch != 13 {
			ch = cbm.CHRIN()
			hscore[cnt] = ch
			cnt += 1 }
			hscore[5] = 0 
			;ch = cbm.CHRIN()
		string.copy(&hscore,scores[row])
		if row == 9 {
			top_score = conv.str2uword(scores[row]) } 		
        }
        
        cbm.CLALL()

 }
 
sub check_score(uword score) -> ubyte {
	ubyte n
	ubyte i
	ubyte j
	str tmp = "?????"
	
	if score < top_score {
		return(10) }
	else {
		for n in 0 to 9 {
			if score > conv.str2uword(scores[n]) {
				if n == 0 {
					j = 0
					string.copy(scores[n],tmp)	}				
				else {
					string.copy(scores[n-1],tmp) 
					j = n-1 
					}
				for i in 8 to j step -1 {
					string.copy(names[i],names[i+1])
					string.copy(scores[i],scores[i+1])	
					}				
								
				string.copy(p_str,names[n]) 
				conv.str_uw0(score)
				string.copy(conv.string_out,scores[n])
				if n != 0 {
					string.copy(tmp,scores[n-1]) }
				
				return(n)
			}
		}	
	}
}
 
 
 
sub print_hiscores() {
	ubyte n
	
		txt.clear_screen()
		txt.plot(10,10)
		txt.print("x-bert high scores")
		txt.plot(10,12)
		txt.print("name")
		txt.plot(20,12)
		txt.print("score")
		txt.plot(10,14)
		
	for n in 0 to 9 {
		txt.plot(5,16+n)
		txt.print_ub(n)
		txt.plot(10,16+n)
		txt.print(names[n])
		txt.plot(20,16+n)
		txt.print(scores[n])
	}
		
	
}
 
sub get_player() {

  txt.plot(2,1)
  txt.print("new hi score, enter initials: ")
  txt.input_chars(p_str)

}

sub get_score() {
	string.copy("??????",s_str)
  txt.plot(2,2)
  txt.print("enter new score: ")
  txt.input_chars(s_str)
  txt.plot(2,3)
  
  scor = conv.str2uword(s_str)
  txt.print_uw(scor)
}
 
 sub write_hiscores() {
	ubyte row
	ubyte cnt
	ubyte[4] hname
	ubyte[7] hscore	
	ubyte ch
		
	cbm.SETLFS(1, 8, 2)

	cbm.SETNAM(len(wfilenam), wfilenam)
	
	cbm.OPEN()
	
	cbm.CHKOUT(1)
	
	for row in 0 to 9 {	
		cnt = 0
		ch = 1
		string.copy(names[row],&hname)
		
		while ch != 0 {
			ch = hname[cnt]
		  	cbm.CHROUT(ch)
	      	cnt += 1 
		}
		ch = 13
		cbm.CHROUT(ch)
		
		cnt = 0
		ch = 1
		string.copy(scores[row],&hscore)
		while ch != 0 {
			ch = hscore[cnt]
		  	cbm.CHROUT(ch)
	      	cnt += 1 
		}
		ch = 13
		cbm.CHROUT(ch)		
    }
        
   cbm.CLALL()
 }
 
 sub getkey() {
	ubyte key = 0
	while key == 0 {
		key = cbm.GETIN() }
	}
	
}