%import syslib
%import string
%import graphics
%import floats
%import conv

main {

str wfilenam = "@0:hiscores.dat,s,w"
str rfilenam = "@0:hiscores.dat,s,r"
str[10] names = ["1??","2??","3??","4??","5??","6??","7??","8??","9??","a??"]
str[10] scores = ["10000","20000","30000","40000","50000","60000","70000","80000","90000","11000"]
str p_str = "???"
uword top_score

sub start() {
	ubyte r

	    void cx16.screen_mode(3, false)     ; low res
    	txt.color2(9,0)                     ; make sure correct screen colors are (re)set
    	txt.clear_screen()
    	
    	get_player()
    	
    	read_hiscores()

    	
    	r = check_score(29500)
    	 	
    	print_hiscores()
    	
    	txt.plot(15,25)
    	txt.print_ub(r)

    	
    	getkey()
    	
}

sub read_hiscores() {
	ubyte row
	ubyte cnt
	ubyte ch
	ubyte lgth
	ubyte[4] hname
	ubyte[7] hscore

		
	lgth = string.length(rfilenam)
	
	cbm.SETLFS(2, 8, 2)
	
	cbm.SETNAM(lgth, rfilenam)
	
	cbm.OPEN()
	
	cbm.CHKIN(2)
	
	txt.nl()
	for row in 0 to 9 {	
		cnt = 0
		ch = 0
		while ch != 13 {
		  ch = cbm.CHRIN()
		  hname[cnt] = ch
	          cnt += 1 }
		  hname[3] = 0
;		  ch = cbm.CHRIN()
		string.copy(&hname,names[row])
		cnt = 0
		ch = 0
		while ch != 13 {
			ch = cbm.CHRIN()
			hscore[cnt] = ch
			cnt += 1 }
			hscore[5] = 0 
;			ch = cbm.CHRIN()
		string.copy(&hscore,scores[row])
		if row == 9 {
			top_score = conv.str2uword(scores[row]) } 		
        }
        
        cbm.CLALL()

 }
 
sub check_score(uword score) -> ubyte {
	ubyte n
	ubyte i
	str tmp = "?????"
	
	if score < top_score {
		return(10) }
	else {
		for n in 0 to 9 {
			if score > conv.str2uword(scores[n]) {
				for i in 8 to n step -1 {
					names[i+1] = names[i]
					scores[i+1] = scores[i] }
				string.copy(p_str,names[n]) 
				conv.str_uw0(score)
				string.copy(conv.string_out,scores[n])
				return(n)
			}
		}	
	}
}
 
;sub new_hiscore(uword tc) {
;  local n
;  
;  if p% = 9 then
;    highscore%(p%) = score%  
;    hiscores$(p%,0) = str$(highscore%(p%),5,0,"0")
;    hiscores$(p%,1) = player$(cur_plyer%)
;  else
;    for n = 8 to p% step -1
;      hiscores$(n+1,0) = hiscores$(n,0)
;      hiscores$(n+1,1) = hiscores$(n,1)
;    next   
;    highscore%(p%) = score%  
;    hiscores$(p%,0) = str$(highscore%(p%),5,0,"0")
;    hiscores$(p%,1) = player$(cur_plyer%)
;  end if
    

;} 
 
sub print_hiscores() {
	ubyte n
	
		txt.clear_screen()
		txt.plot(10,0)
		txt.print("x-bert high scores")
		txt.plot(10,2)
		txt.print("name")
		txt.plot(20,2)
		txt.print("score")
		txt.plot(10,4)
		
	for n in 0 to 9 {
		txt.plot(5,6+n)
		txt.print_ub(n)
		txt.plot(10,6+n)
		txt.print(names[n])
		txt.plot(20,6+n)
		txt.print(scores[n])
	}
		
	
}
 
sub get_player() {

  txt.plot(2,10)
  txt.print("new hi score, enter initials: ")
  txt.input_chars(p_str)

}
 
; sub write_hiscores() {
;	ubyte row
;	ubyte cnt
;	
;	cbm.SETLFS(1, 8, 2)
;
;	cbm.SETNAM(len(wfilenam), wfilenam)
;	
;	cbm.OPEN()
;	
;	cbm.CHKOUT(1)
;	
;		for row in 0 to 239 {
;			cx16.FB_cursor_position(0, row)
 ;       	cx16.FB_get_pixels(&rowbuf_a,320) 
  ;      	
   ;     	for cnt in 0 to 159 {
    ;    		cbm.CHROUT(rowbuf_a[cnt]) }
;        	
;        	for cnt in 0 to 159 {
;        		cbm.CHROUT(rowbuf_b[cnt]) }
;        		
;        	}
;        	
;        cbm.CLALL()
; }
 
 sub getkey() {
	ubyte key = 0
	while key == 0 {
		key = cbm.GETIN() }
	}
	
}